#include "windows.h"
#include "conioex.h"
#include "serial.h"
#include <stdio.h>
#include <time.h>
#include <conio.h>

#define Filename "C:\\Armand van Helden  - When the lights go down (radio edit) 48kHz, Stereo, 16bit.wav"

#define ResetD	1
#define LoadSR	2
#define Escape	14

#define CPUClk	16000000

#define CMDs

void reset_dac(void)
{unsigned char temp[10], j=0;
	temp[j++]=Escape;
	temp[j++]=ResetD;
	SendString(temp,j);
}

void set_samplerate(unsigned int samplerate)
{unsigned char temp[10], j=0;
unsigned int wert;

	wert=(CPUClk/samplerate)-1;

	temp[j++]=Escape;
	temp[j++]=LoadSR;
	temp[j++]=255&(wert>>8);
	temp[j++]=wert&255;
	SendString(temp,j);
}

int main(int argc, char* argv[])
{	
	Serial_Init("COM7", 19200);

FILE *fp;

unsigned int vzeit,i,zeit,frames,zs;
float fps, kbs;
unsigned char temp[2048];
unsigned char datei[1024];
unsigned int j;

zeit=time(0)-1;
fp=fopen (Filename,"rb");

frames=0;

#ifdef CMDs
	reset_dac();

	set_samplerate(48000);
#endif

	gotoxy(1,2); 
	printf ("Playing\n%s",Filename);

	fread(datei,1,44,fp);				//Header entfernen

while (!feof(fp)&&(!kbhit()))			//Daten bis zum Dateiende oder Tastendruck ausgeben
{
	fread(datei,1,1024,fp);				//Daten in Puffer einlesen

	gotoxy(1,6); 
	vzeit=time(0)-zeit;					//Der ganze Block ist nur Statusausgabe
	fps=(float)256*frames/vzeit;
	kbs=(float)	frames/vzeit*j/1024;

	printf ("%4is %2.2f Samples/s %3.2f kB/s\n", vzeit, fps,kbs);
	frames++;


	j=0;								//Daten Konvertieren
	for (i=0; i<512; i++)
	{
	zs=datei[i*2]|(datei[i*2+1]*256);
	zs&=65535;
	zs=zs>>1;							//16bit -> 15bit umwandeln (wegen I2S Interface an SPI)

#ifdef CMDs
	if ((255&(zs>>8))==Escape)			//Daten
		temp[j++]=Escape;
#endif
	temp[j++]=255&(zs>>8);

#ifdef CMDs
	if (((zs/2)&255)==Escape)
		temp[j++]=Escape;
#endif
	temp[j++]=(zs/2)&255;
	}

	SendString(temp, j);				//Daten an USB bergeben
}
	fclose(fp);
	Uninit_Serial();

	return 0;
}

